/* >c.15tdist */
/*-----------------------------------
15 april 2014 same as tdist9.c

14 april 2014 see tmain10.c for changes (actually same as tdist9.c)

these are the distribution dependent subroutines

No graphics calls in these

-------------------------------------*/
#include "threep9.h"

// #include "gengrdef.h"

#define GTOL 1e-4
#define POWELLFTOL 1e-4

#define EVALCUTOFF 1000

/*==== local globals for ncotes ====*/
double flag;
double aerr;
double errest;
double relerr;


extern long hitail;
extern long model;
extern long componentmodel;
extern long spacingsflag;   /* for choice of function to be maximised */
extern long show;
extern long numevals;
extern long cdfavail;
extern double leftendvalue;
/*
extern double gamlog, gamlog1, gamlog2;
*/
extern long numcomps;
extern long maxnumlevs;
extern long effort;
extern double * yobs;
extern long n;
extern long akey;


/**** quanc8 ****/

double quanc8(a,b,pohat)
 double a,b;
 double * pohat;

 {
 extern double myabs(double);
 extern double fnf(double, double *,long);
 
 static double qright[33], eff[17], x[17],fsave[9][33], xsave[9][33];
 
 static double area;
 
 static double cor11;
 
 static double esterr;
 
 static double fmax;
 static double fmin;
 static double f0;

 static long i;
 
 static long j;

 static long level;
 static long levmin;
 static long levmax;
 static long levout;

 static long nim;

 static long nomax;
 
 static long nofin;
 static long nofun;
 
 static double qdiff;
 static double qleft;
 static double qnow;
 static double qprev;
 
 static double result;
 static double tolerr;

 static double st;
 static double stone;

 static long tni;
 static double temp;
 static double tr;

 static double w0,w1,w2,w3,w4;

 static double x0;
 
/*-----------*/

/*=== ncotes error tolerance setup ===*/
 relerr=1e-6;
 aerr=0.0;   /* === abs error tol === */


 levmin=1;
 levmax=30;
 levout=6;

 nomax = 5000;  /*was 5000 then 32*/;

 nofin = nomax - 8*(levmax-levout+pow(2,(levout+1)) );
 w0=3956.0/14175.0;
 w1=23552.0/14175.0;
 w2=-3712.0/14175.0;
 w3=41984.0/14175.0;
 w4=-18160.0/14175.0;

 /*--init running sums to Zero--*/

 flag=0;
 result=0;
 cor11=0;
 errest=0;
 area=0;
 nofun=0;
 if (a>=b) return(0);

/*--init for 1st intvl--*/
 level=0;
 nim=1;
 x0=a;

x[16]=b;
qprev=0;

f0=fnf(x0,pohat, model);
fmax=f0;
fmin=f0;

stone=(b-a)/16       ;
x[8]=(x0+x[16])/2    ;
x[4]=(x0+x[8])/2     ;
x[12]=(x[8]+x[16])/2 ;
x[2]=(x0+x[4])/2     ;
x[6]=(x[4]+x[8])/2   ;
x[10]=(x[8]+x[12])/2 ;
x[14]=(x[12]+x[16])/2;

for(j=2;j<=16;j+=2)
 {
 eff[j]=fnf(x[j],pohat,model);

/*
 printf("j= %d \n",j); 
*/

 if( fmax<eff[j] ) fmax=eff[j];
 if( fmin>eff[j] ) fmin=eff[j];
 }

nofun=9;

/*central calculation */

lab1030:

x[1]=(x0+x[2])/2;
eff[1]=fnf(x[1],pohat,model);

for (j=3; j<=15; j+=2)
 {
 x[j]=(x[j-1]+x[j+1])/2;
 eff[j]=fnf(x[j],pohat,model);

 }
 
 nofun=nofun+8;
 
 st=(x[16]-x0)/16;
 
 qleft=(w0*(f0+eff[8])+w1*(eff[1]+eff[7])+w2*(eff[2]+eff[6])+w3*(eff[3]+eff[5])+w4*eff[4])*st;
 qright[level+1]=(w0*(eff[8]+eff[16])+w1*(eff[9]+eff[15])+w2*(eff[10]+eff[14])+w3*(eff[11]+eff[13])+w4*eff[12])*st;

 qnow=qleft+qright[level+1];

 qdiff=qnow-qprev;

 area=area+qdiff;
 
 /* intvl cgce test  */
 esterr=myabs(qdiff)/1023;

 tr=relerr*myabs(area);
 if(aerr>tr) tr=aerr;
 tolerr=tr*myabs(st)/stone;
 if( level<levmin) goto lab1260;
 if( level>=levmax) goto lab1470;
 if( nofun>nofin) goto lab1420;
 if( esterr<=tolerr) goto lab1490;

/* no cgce*/
lab1260:
 nim=2*nim;
 level=level+1;

/* store rh els for future use */
 for(i=1;i<=8;i++)
  {
  fsave[i][level]=eff[i+8];
  xsave[i][level]=x[i+8];
  }

 /*
 assemble lh els for use now
 */
 qprev=qleft;
 
 for(i=1;i<=8;i++)
  {
  j=-i;
  eff[2*j+18]=eff[j+9];
  x[2*j+18]=x[j+9];
  }
  goto lab1030;
 
 /*
 trouble section
 */
 lab1420:
  nofin=2*nofin;
  levmax=levout;
  flag=flag+(b-x0)/(b-a);
  goto lab1490;
 
 /* current lev is max */
 lab1470:
  flag=flag+1;

 /*--intvl cged, add to sums--*/
 lab1490:
  result=result+qnow;


  errest=errest+esterr;
  cor11=cor11+qdiff/1023;
 
/*--locate next intvl--*/
 lab1530:
  tni=2*(long)(nim/2);
  if (nim==tni) goto lab1580;
 nim=nim/2;
 level=level-1;
 goto  lab1530;
 lab1580:
  nim=nim+1;
 
  if (level<=0) goto lab1700;
 
 /*-- assemble els for next intvl --*/

 qprev=qright[level];
 x0=x[16];
 f0=eff[16];
 for(i=1;i<=8;i++)
  {
  eff[2*i]=fsave[i][level];
  x[2*i]=xsave[i][level];
  }
 goto  lab1030;

 /*
finalise and return
*/

lab1700:
 result=result+cor11;

 /*-- make sure errest<roundofferr --*/
 if (errest==0.0) return(result);
 
 lab1730:

 temp=myabs(result)+errest;
 if (temp!=myabs(result)) return(result);
 errest=2*errest;
 goto  lab1730;

}

double myabs(x)
 double x;
 {
 if(x>0) return(x);
 else return(-x);
 }


/* ============= calcs explicit cdf ============== */
double explicitcdf(xt, pohat)
double xt;
double * pohat;
{
   double gammalog(double, long);
   double bigphi(double);
   double incompgam(double, double, double, long);
   double WeibAlfa(double, double);

   static double xd;

   static double cdf;
   static double yt;

   static double Galfa, Gbeta;
   static double Walfa, Wbeta;
   static double Xalfa, Xbeta;
   static double Lksi, Lsig;
   static double Imu, Ilam;

   static long ifault = 0;
   static long i;
   static double xtemp;
   static double p2;

   switch(model)
   {

     case MODEL:
       cdf = exp(-pohat[5])*bigphi((xt - pohat[1])/pohat[2]);
       cdf += (1.0-exp(-pohat[5])) *bigphi((xt - pohat[3])/pohat[4]);
       break;

     case BURR:
       cdf = 1.0 -
          pow( 1.0 + pow(xt/pohat[1] , pohat[2])/pohat[3], -pohat[3] );
       break;

     case XMIXTURE:
#if 0 // orig case
       cdf = 0.0;
       for(i=1;i<=numcomps;i++)
       {
          xd = (xt - pohat[3*(i-1)+1])/pohat[3*(i-1)+2];
          if(xd<-100.0) xd = -100.0;
          yt = exp( -exp(-xd));
          cdf += pohat[3*(i-1)+3] * yt;
       }
#endif
#if 1 // mean = p1 SD=p2 alfa was p1 beta was p2
       cdf = 0.0;
       for(i=1;i<=numcomps;i++)
       {
          Xalfa = pohat[3*(i-1)+1] - .45006*pohat[3*(i-1)+2];
          Xbeta = 0.77970 * pohat[3*(i-1)+2];
          xd = (xt - Xalfa)/Xbeta;
          if(xd<-100.0) xd = -100.0;
          yt = exp( -exp(-xd));
          cdf += pohat[3*(i-1)+3] * yt;
       }
#endif
       break;

     case NXMIXTURE:
#if 0 // orig case
       cdf = 0.0;
       for(i=1;i<=numcomps;i++)
       {
	  xd = (xt - pohat[3*(i-1)+1])/pohat[3*(i-1)+2];
          if(xd>100.0) xd = 100.0;
          yt = 1.0 - exp( -exp(xd));
          cdf += pohat[3*(i-1)+3] * yt;
       }
#endif
#if 1  // mean = p1 SD=p2 alfa was p1 beta was p2
       cdf = 0.0;
       for(i=1;i<=numcomps;i++)
       {
          Xalfa = pohat[3*(i-1)+1] + .45006*pohat[3*(i-1)+2];
          Xbeta = 0.77970 * pohat[3*(i-1)+2];
          xd = (xt - Xalfa)/Xbeta;
          if(xd>100.0) xd = 100.0;
          yt = 1.0 - exp( -exp(xd));
          cdf += pohat[3*(i-1)+3] * yt;
       }
#endif
       break;

     case WMIXTURE:
#if 0 // orig case
       cdf = 0.0;
       if (xt<=0.0) xt = 0.0000001;
       for(i=1;i<=numcomps;i++)
       {
          p2 = pohat[3*(i-1)+2];
          if (p2 > 150.0) { p2 = 150.0; } //restrict the power param
          
          yt = pow( xt/pohat[3*(i-1)+1], p2 );

          cdf += pohat[3*(i-1)+3] *
                 ( 1.0 - exp(-yt ) );
       }
#endif
#if 1 // p1 =mean p2 = sig case: alfa was p2, beta was p1
       cdf = 0.0;
       if (xt<=0.0) xt = 0.0000001;
       for(i=1;i<=numcomps;i++)
       {
          Walfa = WeibAlfa(pohat[3*(i-1)+1], pohat[3*(i-1)+2]);
          Wbeta = pohat[3*(i-1)+1]/exp( gammalog(1. + 1.0/Walfa, ifault) );
          p2 = Walfa;
          if (p2 > 150.0) { p2 = 150.0; } //restrict the power param
          
          yt = pow( xt/Wbeta, p2 );

          cdf += pohat[3*(i-1)+3] *
                 ( 1.0 - exp(-yt ) );
       }
#endif
       break;

     case NMIXTURE:
       cdf = 0.0;
       for(i=1;i<=numcomps;i++)
       {
          cdf += pohat[3*(i-1)+3] *
                      bigphi( (xt - pohat[3*(i-1)+1])/pohat[3*(i-1)+2] );
       }
       break;

     case LMIXTURE:
#if 0 // orig p1 = ksi p2 = sig  case
       cdf = 0.0;
       if (xt<=0.0) xt = 0.000001;
       for(i=1;i<=numcomps;i++)
       {
          cdf += pohat[3*(i-1)+3] *
                      bigphi( (log(xt) - pohat[3*(i-1)+1])/pohat[3*(i-1)+2] );
       }
#endif
#if 1 // p1 = mean p2 = SD  case
       cdf = 0.0;
       if (xt<=0.0) xt = 0.000001;
       for(i=1;i<=numcomps;i++)
       {
          xd = 1. + pow(pohat[3*(i-1)+2]/pohat[3*(i-1)+1], 2.);
          if(xd < 0.00000001) xd = 0.00000001;
          xd = log(xd);
          Lksi = log(pohat[3*(i-1)+1]) - 0.5 * xd;
          Lsig = sqrt( xd );
          cdf += pohat[3*(i-1)+3] *
                      bigphi( (log(xt) - Lksi)/Lsig );
       }
#endif
       break;

     case GMIXTURE:
#if 0 // p1=beta p2=alfa case
       if (xt<=0.0) xt = 0.000001;
       cdf = 0.0;
       for(i=1;i<=numcomps;i++)
       {       
          cdf += pohat[3*(i-1)+3] *
                   incompgam(xt/pohat[3*(i-1)+1], pohat[3*(i-1)+2],
                      gammalog(pohat[3*(i-1)+2],ifault), ifault);
       }
#endif
#if 1 // p1=mu p2=sig case
       if (xt<=0.0) xt = 0.000001;
       cdf = 0.0;
       for(i=1;i<=numcomps;i++)
       {       
          Galfa=pow(pohat[3*(i-1)+1]/pohat[3*(i-1)+2], 2.);
          Gbeta=pohat[3*(i-1)+2]*pohat[3*(i-1)+2]/pohat[3*(i-1)+1];
          cdf += pohat[3*(i-1)+3] *
                   incompgam(xt/Gbeta, Galfa,
                      gammalog(Galfa, ifault), ifault);
       }
#endif

       break;

     case IMIXTURE:
#if 0 // This is where param2 = lambda
       cdf = 0.0;
       if (xt<=0.0) xt = 0.000001;
       for(i=1;i<=numcomps;i++)
       {
          if(pohat[3*(i-1)+2]/pohat[3*(i-1)+1] < 100.0)
             cdf += pohat[3*(i-1)+3] *
                 (
                  bigphi(((xt/pohat[3*(i-1)+1])-1.) * 
                  sqrt(pohat[3*(i-1)+2]/xt)) +
                  exp(2.*pohat[3*(i-1)+2]/pohat[3*(i-1)+1])*
                  bigphi(-((xt/pohat[3*(i-1)+1])+1.)*sqrt(pohat[3*(i-1)+2]/xt))
                 );
          else
             cdf += pohat[3*(i-1)+3] * 
                    bigphi( (xt-pohat[3*(i-1)+1])/
                            sqrt( pow(pohat[3*(i-1)+1],3.)/pohat[3*(i-1)+2] )
                          );
       }
#endif
#if 1 // This is where p2 = SD
       cdf = 0.0;
       if (xt<=0.0) xt = 0.000001;
       for(i=1;i<=numcomps;i++)
       {
          Imu = pohat[3*(i-1)+1];
          Ilam = pow(Imu, 3.) * pow(pohat[3*(i-1)+2], -2.0);
          if(Ilam/Imu < 100.0)
             cdf += pohat[3*(i-1)+3] *
                 (
                  bigphi(((xt/Imu)-1.) * sqrt(Ilam/xt)) +
                  exp(2.*Ilam/Imu)* bigphi(-((xt/Imu)+1.)*sqrt(Ilam/xt) )
                 );
          else
             cdf += pohat[3*(i-1)+3] * 
                    bigphi( (xt-Imu)/ sqrt( pow(Imu, 3.)/Ilam ) );
       }

#endif
       break;

   }
   return cdf;
}

/*=============== The pdf: fnf(.) =================*/
double fnf(xt, pohat, distribution)
double xt;
double * pohat;
long distribution;

{
double gammalog(double, long);
double WeibAlfa(double, double);

/*
extern double gamlog, gamlog1, gamlog2;
*/
static long i;
static long ifault;
static double temp, yt;
static double t1,t2;
static double xtemp;
static double p2;
static double xd;
static double x1;

static double Galfa, Gbeta;
static double Walfa, Wbeta;
static double Xalfa, Xbeta;
static double Lksi, Lsig;
static double Imu, Ilam;



switch(distribution) // ----- pdfs -----
     {

     case EXTREME2:
#if 0 // orig case
       xd = (xt - pohat[1])/pohat[2];
       if(xd<-100.0) xd = -100.0;
       temp =  exp(-exp(-xd)) * exp(-xd) / pohat[2];
#endif
#if 1 // case mean = p1 SD = p2 alfa was p1 beta was p2
       Xalfa = pohat[1] - .45006*pohat[2];
       Xbeta = 0.77970 * pohat[2];
       xd = (xt - Xalfa)/Xbeta;
       if(xd<-10.0) xd = -10.0;
       temp =  exp(-exp(-xd)) * exp(-xd) / Xbeta;
#endif
       break;

     case NEXTREME2:
#if 0 // orig case
       xd = (xt - pohat[1])/pohat[2];
       if(xd>100.0) xd = 100.0;
       temp =  exp(-exp(xd)) *
               exp(xd) / pohat[2];
#endif
#if 1 // case mean = p1 SD = p2 alfa was p1 beta was p2
       Xalfa = pohat[1] + .45006*pohat[2];
       Xbeta = 0.77970 * pohat[2];
       xd = (xt - Xalfa)/Xbeta;
       if(xd>10.0) xd = 10.0;
       temp =  exp(-exp(xd)) * exp(xd) / Xbeta;
#endif
       break;

     case WEIBULL2:
#if 0 // orig case
       if(xt<=0.00001) xt = 0.00001;
       xd = pohat[1];
       if(xd<0.0)  { printf("xd=%lf\n",xd); getch();}
       p2 = pohat[2];
       yt = p2 * log( xt/xd );
       if( yt>100.0 )
       {
          // printf("yt = %le\n",yt);
          // getch();
          yt = 100.0;
       }
       temp = exp( log( p2 ) + yt - exp(yt) - log(xt) ) ;
#endif
#if 1 // p1 =mean p2 = sig case: alfa was p2, beta was p1
       if(xt<=0.00001) xt = 0.00001;
       Walfa = WeibAlfa(pohat[1], pohat[2]);
       Wbeta = pohat[1]/exp( gammalog( 1.0 + 1.0/Walfa, ifault) );

       xd = Wbeta;
       if(xd<=0.0)  { printf("xd=%lf\n",xd); getch();}
       p2 = Walfa;
       if(p2<0.00000001) p2 = 0.00000001;
       x1 = xt/xd;
       if(x1<=0.00000001) x1 = 0.00000001;
       yt = p2 * log( x1 );
       if( yt>100.0 )
       {
          // printf("yt = %le\n",yt);
          // getch();
          yt = 100.0;
       }
       temp = exp( log( p2 ) + yt - exp(yt) - log(xt) ) ;
#endif
       break;

     case INVG2:
#if 0 // case pohat2 = lam
       temp = 0.5 * ( log(pohat[2]) - log(2. * PI) );
       temp = temp - 1.5*log(xt) 
                    - pohat[2] * pow( xt/pohat[1] -1. , 2.) / (2.* xt);
       if(temp>-50)
          temp = exp (temp);
       else temp = 0.0;
#endif
#if 1 // case p2 = SD
       Imu = pohat[1];
       Ilam = pow(Imu, 3.) * pow(pohat[2], -2.0);

       temp = 0.5 * ( log(Ilam) - log(2. * PI) );
       temp = temp - 1.5*log(xt) 
                    - Ilam * pow( xt/Imu -1. , 2.) / (2.* xt);
       if(temp>-50)
          temp = exp (temp);
       else temp = 0.0;
#endif
       break;

     case GAMMA2:
#if 0 // case p2=alfa, p1=beta
      if(xt<=0.0) xt = 0.00001;
      t1 =   (pohat[2]-1.)*log(xt) -
                      pohat[2]*log(pohat[1]) -
                      gammalog(pohat[2],ifault) -  
                      (xt/pohat[1]);
      if(t1>50.0) printf("t1= %lf\n",t1);
      if( t1>-20 )
         temp = exp( t1 );
      else temp = 0.0;
#endif
#if 1 // case p1=mu, p2=sig
      if(xt<=0.0) xt = 0.00001;
      Galfa=pow(pohat[1]/pohat[2], 2.);
      Gbeta=pohat[2]*pohat[2]/pohat[1];
      t1 =   (Galfa-1.)*log(xt) -
                      Galfa*log(Gbeta) -
                      gammalog(Galfa,ifault) -  
                      (xt/Gbeta);
      if(t1>50.0) printf("t1= %lf\n",t1);
      if( t1>-20 )
         temp = exp( t1 );
      else temp = 0.0;
#endif
      break; 

     case LOGNORM2: 
#if 0 // orig case
       if(xt<=0.0) xt = 0.00001;
       yt = (log(xt)-pohat[1])/pohat[2];
       xd = (xt) * sqrt( 2.* PI ) * pohat[2];
       if(xd < 0.00000001) xd = 0.00000001;
       yt = -0.5*yt*yt-log( xd );
       if(yt<-200)
          temp = 0.0;
       else 
          temp = exp(yt);
#endif
#if 1 // case p1 = mean  p2 = SD
       if(xt<=0.0) xt = 0.00001;
       x1 = pohat[1];
       if(x1 < 0.00000001) x1 = 0.00000001;
       xd = 1. + pow(pohat[2]/pohat[1], 2.);
       if(xd < 0.00000001) xd = 0.00000001;
       xd = log(xd);
       Lksi = log(x1) - 0.5*xd;
       Lsig = sqrt( xd );
       yt = (log(xt)-Lksi)/Lsig;
       xd = (xt) * sqrt( 2.* PI ) * Lsig;
       if(xd < 0.00000001) xd = 0.00000001;
       yt = -0.5*yt*yt-log( xd );
       if(yt<-200)
          temp = 0.0;
       else 
          temp = exp(yt);
#endif
       break;

     case NORMAL:
       t1 = pow( 2.0*PI, -0.5)/pohat[2];
       t2 = -(xt - pohat[1]) * (xt - pohat[1])/(2.0 * pohat[2] * pohat[2]);
   
       if (t2<-500)
          temp = 0;
       else
          temp = t1*exp(t2);
       break;

     case MODEL:
       temp = exp(-pohat[5])*pow(2.0*PI*pohat[2]*pohat[2], -0.5) *
             exp( -(xt - pohat[1])*(xt - pohat[1])/(2.0*pohat[2]*pohat[2]) );

       temp += (1.0-exp(-pohat[5]))*pow(2.0*PI*pohat[4]*pohat[4], -0.5) *
             exp( -(xt - pohat[3])*(xt - pohat[3])/(2.0*pohat[4]*pohat[4]) );
       break;

     case BURR:
       temp = pohat[2]*pow(xt/pohat[1],pohat[2])/
       (xt* pow( 1.0 + pow(xt/pohat[1] , pohat[2])/pohat[3], pohat[3]+1. ) );
       break;

     case XMIXTURE:
#if 0 // orig case
       temp = 0.0;
       for(i=1;i<=numcomps;i++)
       {
          xd = (xt - pohat[3*(i-1)+1])/pohat[3*(i-1)+2];
          if (xd < -100.0) xd = -100;
          yt = exp ( -exp(-xd) ) * exp(-xd) /  pohat[3*(i-1)+2];
          temp += pohat[3*(i-1)+3] * yt;
       }
#endif
#if 1 // case mean = p1 SD = p2 alfa was p1 beta was p2
       temp = 0.0;
       for(i=1;i<=numcomps;i++)
       {
          Xalfa = pohat[3*(i-1)+1] - .45006*pohat[3*(i-1)+2];
          Xbeta = 0.77970 * pohat[3*(i-1)+2];
          xd = (xt - Xalfa)/Xbeta;
          if (xd < -10.0) xd = -10;
          yt = exp ( -exp(-xd) ) * exp(-xd) / Xbeta;
          temp += pohat[3*(i-1)+3] * yt;
       }
#endif
       break;

     case NXMIXTURE:
#if 0 // orig case
       temp = 0.0;
       for(i=1;i<=numcomps;i++)
       {
          xd = (xt - pohat[3*(i-1)+1])/pohat[3*(i-1)+2];
          if(xd>100.0) xd = 100.0;
          yt =  exp(-exp(xd)) * exp(xd) / pohat[3*(i-1)+2];
          temp += pohat[3*(i-1)+3] * yt;
       }
#endif
#if 1 // case mean = p1 SD = p2 alfa was p1 beta was p2
       temp = 0.0;
       for(i=1;i<=numcomps;i++)
       {
          Xalfa = pohat[3*(i-1)+1] + .45006*pohat[3*(i-1)+2];
          Xbeta = 0.77970 * pohat[3*(i-1)+2];
          xd = (xt - Xalfa)/Xbeta;
          if(xd>10.0) xd = 10.0;
          yt =  exp(-exp(xd)) * exp(xd) / Xbeta;
          temp += pohat[3*(i-1)+3] * yt;
       }
#endif
       break;

     case WMIXTURE:
#if 0 // orig case
       if(xt<=0.00001) xt = 0.00001;
       temp = 0.0;

       for(i=1;i<=numcomps;i++)
       {
          xd = pohat[3*(i-1)+1];
          if(xd<0.0)  { printf("xd=%lf\n",xd); getch();}
          p2 = pohat[3*(i-1)+2];
          yt = p2 * log( xt/xd );
          if( yt>100.0 )
          {
            // printf("yt = %le\n",yt);
            // getch();
             yt = 100.0;
          }
          temp += pohat[3*(i-1)+3] *
                  exp( log( p2 ) + yt - exp(yt) - log(xt) ) ;
       }
#endif
#if 1 // p1 =mean p2 = sig case: alfa was p2, beta was p1
       if(xt<=0.00001) xt = 0.00001;
       temp = 0.0;
       for(i=1;i<=numcomps;i++)
       {
          Walfa = WeibAlfa(pohat[3*(i-1)+1], pohat[3*(i-1)+2]);
          Wbeta = pohat[3*(i-1)+1]/exp( gammalog( 1.0 + 1.0/Walfa, ifault) );
          xd = Wbeta;
          if(xd<=0.0)  { printf("xd=%lf\n",xd); getch();}
          p2 = Walfa;
          if(p2<0.00000001) p2 = 0.00000001;
          x1 = xt/xd;
          if(x1<0.00000001) x1 = 0.00000001;
          yt = p2 * log( x1 );
          if( yt>100.0 )
          {
            // printf("yt = %le\n",yt);
            // getch();
             yt = 100.0;
          }
          temp += pohat[3*(i-1)+3] *
                  exp( log( p2 ) + yt - exp(yt) - log(xt) ) ;
       }
#endif
       break;

     case NMIXTURE:
       temp = 0.0;
       for(i=1;i<=numcomps;i++)
       {
          temp += pohat[3*(i-1)+3] *
                  ( sqrt( 1.0/(2.0*PI) )/pohat[3*(i-1)+2] ) *
                  exp( - (xt - pohat[3*(i-1)+1]) *
                         (xt - pohat[3*(i-1)+1]) / 
                        ( 2.0 * pohat[3*(i-1)+2] *pohat[3*(i-1)+2] ) );
          
           //printf("i=%d xt = %lf p1 = %lf p2 = %lf p3 = %lf\n", i, xt, pohat[1], pohat[2], pohat[3]);
           //getch();

       }
       break;

     case LMIXTURE:
#if 0 // original case
       if(xt<=0.0) xt = 0.00001;
       temp = 0.0;
       for(i=1;i<=numcomps;i++)
       {
          yt = (log(xt)-pohat[3*(i-1)+1])/pohat[3*(i-1)+2];
          xd = xt*sqrt(2.*PI)*pohat[3*(i-1)+2];
          if(xd<=0.00000001) xd = 0.00000001;
          yt = -0.5*yt*yt-log(xd);
          if(yt>-100.)
             temp += pohat[3*(i-1)+3]*exp(yt);
       }
#endif
#if 1 // p1 =mean p2 = SD  case
       if(xt<=0.0) xt = 0.00001;
       temp = 0.0;
       for(i=1;i<=numcomps;i++)
       {
          x1 = pohat[3*(i-1)+1];
          if(x1 < 0.00000001) x1 = 0.00000001;
          xd = 1. + pow(pohat[3*(i-1)+2]/pohat[3*(i-1)+1], 2.);
          if(xd < 0.00000001) xd = 0.00000001;
          xd = log(xd);
          Lksi = log(x1) - 0.5 * xd;
          Lsig = sqrt( xd );
          yt = (log(xt)-Lksi)/Lsig;
          xd = xt*sqrt(2.*PI)*Lsig;
          if(xd<=0.00000001) xd = 0.00000001;
          yt = -0.5*yt*yt-log(xd);
          if(yt>-100.)
             temp += pohat[3*(i-1)+3]*exp(yt);
       }
#endif
       break;

     case GMIXTURE:
#if 0 // p1=beta p2=alfa case
      if(xt<=0.0) xt = 0.00001;
      temp = 0.0;
       for(i=1;i<=numcomps;i++)
       {

          if(pohat[3*(i-1)+1]<=0.000001)
          {
              pohat[3*(i-1)+1] = 0.000001;
          }
          t1 =        (pohat[3*(i-1)+2]-1.)*log(xt) -
                      pohat[3*(i-1)+2]*log(pohat[3*(i-1)+1]) -
                      gammalog(pohat[3*(i-1)+2],ifault) -  
                      (xt/pohat[3*(i-1)+1]);
          if( t1>-20 )
             yt = pohat[3*(i-1)+3] * exp( t1 );
          else yt = 0.0;
          /*
          printf("i=%d yt = %lf p2 = %lf p1 = %lf\n", i, yt, pohat[2], pohat[1]);
          */
          temp += yt;
       }
#endif
#if 1 // p1=mu p2=sig case
      if(xt<=0.0) xt = 0.00001;
      temp = 0.0;
       for(i=1;i<=numcomps;i++)
       {
          Galfa=pow(pohat[3*(i-1)+1]/pohat[3*(i-1)+2], 2.);
          Gbeta=pohat[3*(i-1)+2]*pohat[3*(i-1)+2]/pohat[3*(i-1)+1];
          if(Gbeta<=0.000001)
          {
              Gbeta = 0.000001;
          }
          t1 =        (Galfa-1.)*log(xt) -
                      Galfa*log(Gbeta) -
                      gammalog(Galfa, ifault) -  
                      (xt/Gbeta);
          if( t1>-20 )
             yt = pohat[3*(i-1)+3] * exp( t1 );
          else yt = 0.0;
          
          /*
          printf("i=%d yt = %lf p2 = %lf p1 = %lf\n", i, yt, pohat[2], pohat[1]);
          getch();

          */

          temp += yt;
       }
#endif
       if (temp == 0.)
       {
          temp = 0.00000000001;
       }	
       break;

     case IMIXTURE:
#if 0 // case param2 = lam
       if(xt<=0.0) xt = 0.00001;
       temp = 0.0;
       for(i=1;i<=numcomps;i++)
       {
          yt = 0.5 * ( log(pohat[3*(i-1)+2]) - log(2. * PI) );
          yt = yt - 1.5*log(xt) 
                  - pohat[3*(i-1)+2] 
                  * pow( xt/pohat[3*(i-1)+1] -1. , 2.) / (2.* xt);
          if(yt>-50)
             temp += pohat[3*(i-1)+3] * exp (yt);
       }
#endif
#if 1 // case param2 = SD
       if(xt<=0.0) xt = 0.00001;
       temp = 0.0;
       for(i=1;i<=numcomps;i++)
       {
          Imu = pohat[3*(i-1)+1];
          Ilam = pow(Imu, 3.) * pow(pohat[3*(i-1)+2], -2.0);
          yt = 0.5 * ( log( Ilam ) - log(2. * PI) );
          yt = yt - 1.5*log(xt) 
                  - Ilam 
                  * pow( xt/Imu -1. , 2.) / (2.* xt);
          if(yt>-50)
             temp += pohat[3*(i-1)+3] * exp (yt);
       }
#endif
       break;

     }

return(temp);
}

double WeibAlfa(double mean, double sig)
{
   static double x, y;
   static double a, b, c;
   static double s;
   static double a0, b0, c0, d0, e0, f0;
   // a = 0.1827;
   // b = -0.2374;
   // c = 0.6786;

   // a0=0.516233985;
   // b0=0.756150024;
   // c0=0.307930887;
   // d0=6.176611768;
   // e0=-0.558246303;
   // f0=0.725460257;

   a0 = 0.52820989;
   b0 = 0.756526962;
   c0 = 0.313230653;
   d0 = 6.179815695;
   e0 = -0.556127877;
   f0 = 0.705689441;

   x = log( 1.+ sig*sig/(mean*mean) );
   if(x<=0.00000001) x = 0.00000001;
   y = log( x );
   // s = a -0.75*(y+b) - 0.25 * sqrt( (y+b)*(y+b) + 8.0*c );   
   s=a0-b0*y-c0*sqrt(d0+e0*y+f0*y*y);

   return exp(s);
}

double leftendfind(leftendflag,pohat,sampmean,sampsig)
long leftendflag;
double * pohat;
double sampmean, sampsig;
{
//   extern double quanc8(double, double, double *);
//   extern double explicitcdf( double, double *);

/*
   extern double gamlog, gamlog1;
*/
static char akey;
static double aa0;
static double accupercent;

static double cdf,cdflo,cdfmid,cdfhi;

static double pvalue;

static double segval;

static double xlo,xmid,xhi;


   switch(leftendflag)
   {
   case -1: /* endpolong not known */

   pvalue = 0.0001;
   accupercent = 0.00001*sampsig;
   if(cdfavail==1)
   {
      xlo = sampmean+2.0*sampsig;
      cdflo = explicitcdf(xlo, pohat);
      while (cdflo>pvalue)
      {
         cdfhi = cdflo; xhi = xlo;
         xlo -= sampsig/2.0;
         cdflo = explicitcdf(xlo, pohat);
      }

      /*-- here cdflo <= pvalue < cdfhi  --*/
      xmid = (xhi + xlo)/2.;
calclabelb:
      cdfmid =  explicitcdf(xmid,pohat);
      if (xhi - xlo < accupercent)
      {
         aa0 = xmid;
/*
         printf("aa0 percentile=%lf with cdf=%lf\n",aa0, cdfmid);  
*/
         goto foundpb;
      }
      if (cdfmid>pvalue) 
      {
         xhi = xmid;
         xmid = (xhi + xlo)/2.;
         goto calclabelb;    
      }
      if (cdfmid<=pvalue)
      {
         xlo = xmid;
         xmid = (xhi + xlo)/2.;
         goto calclabelb;
      } 
foundpb:
      ;
/*
      printf("key to cont");
      akey = getch();
*/
   }/* cdfavail==1 */

   if(cdfavail==0)
   {
      xmid = sampmean+sampsig/10.0;
      xlo = xmid - sampsig/10.0;
      do
      {
         xmid = xlo;
         xlo -= sampsig/10.0;
         segval =  quanc8(xlo,xmid,pohat);
         printf("xlo=%lf xmid = %lf segval =%lf\n",xlo,xmid,segval);
      }while(segval>.00005);

      aa0 = xlo;
      printf("Possible leftend found=%lf press key\n",aa0); getch();

      xmid = sampmean-sampsig/10.0;
      xhi = xmid + sampsig/10.0;
      do
      {
         xmid = xhi;
         xhi+= sampsig/10.0;
         segval =  quanc8(xmid,xhi,pohat);
         printf("xmid=%lf xhi = %lf segval =%lf\n",xmid,xhi,segval);
      }while(segval>.00005);

      printf("Possible rightend found=%lf press key\n",xhi); getch();

      segval =   quanc8(xlo,xhi,pohat);
      printf("xlo=%lf xhi = %lf segval =%lf press key\n",xlo,xhi,segval);
      getch();
   } /* cdfavail == 0 */

   break;

   case 0: aa0 = 0.000001; break;

   case 1: aa0 = pohat[1] + 0.000001 ; break;

   case 2: aa0 = pohat[2] + 0.000001 ; break;

   case 3: aa0 = pohat[3] + 0.000001 ; break;
   }

   return aa0;

}

