/*---- 15tgraph2.c
---------------------*/


#include "threep9.h"

#define OUTPUTFILE 1
#define GRAPHICSON 0


#if GRAPHICSON
   #include "gengrdef.h"
#else
   #define HRES 640
   #define VRES 480
#endif

/* ==== globals ==== */
extern double gamlog,gamlog1,gamlog2;
extern long model;
/*==== local globals for ncotes ====*/
double flag;
double aerr;
double errest;
double relerr;
/*==== end of local globals ====*/


void graphplot(fdp, yobsno, n, pohat, Dvalflag, Dval, j0, j1, j2, j3)

FILE * fdp;
double * yobsno;
long n;
double * pohat;
long Dvalflag;
double * Dval;
long j0, j1, j2, j3;

/*==== graph plot ====*/
{
extern long cdfavail;
extern long hitail;
extern double leftendvalue;
extern long componentmodel;
extern long numcomps;

double explicitcdf(double,double*);
double incompgam(double,double,double,long);
double gammalog(double, long);
double bigphi(double);
double fnf(double, double*, long);

/*==== ncotes call ====*/
double quanc8(double, double, double * );
/*====*/

char akey;
double alpha;
double aa,bb;
double accupercent;

double cellht, ct;
double cdf, cdflo,cdfhi,cdfmid;

double dstep;
double Dvalmax,Dvalmin;

long firstdrawnflag;   /*$$$$$*/

long i,ii;
long ifault = 0;

long j;

long n1,numpts,numpdfpts,numhistpts;

#if WATCOM
static double param[PSIZE];
static double pdfvalo[NSIZE];
static double histopdf[NSIZE];
#else
double param[PSIZE];
double pdfvalo[NSIZE];
double histopdf[NSIZE];
#endif

double pvalue;

double segval;

double * thetaptr;

double xaxislength;         /*$$$$$*/
double xscale,xstep,xsteppdf,xstephist;
double xt,x0,x1,xt0,xt1;
double xlo,xhi,xmid;

double yaxislength;         /*$$$$$*/
double ymax;
double yscale,ystep;       /*$$$$$*/
double y0;
double yt,yt0,yt1;


#if GRAPHICSON
  Initgraphics();
#endif

/*=== ncotes error tolerance setup ===*/
relerr=1e-6;
aerr=0.0;   /* === abs error tol === */

dstep=HRES/( 200.*log( (double)n ) );

numpts = n;

/* === set range limits === */
 aa = leftendvalue;
 bb = yobsno[numpts];

 numpdfpts = 1000;/*$$$$$ was 50 */
 numhistpts =  (numpts/2);
 if(numhistpts<5) numhistpts = 5;
 if(numhistpts>400) numhistpts = 400; // was 100 28 July 2013


 /* == adjust the of x-axis ==*/
 x0 = aa;
 ymax = 0.0;
 /*- calc pdfvals and find the largest in the range to be drawn -*/
 for(ii=1;ii<=numpdfpts;ii++)
 {
    pdfvalo[ii] = fnf(x0,pohat,model);
    if( (ymax<pdfvalo[ii]) ) ymax = pdfvalo[ii];
/*    
    printf("pdf(%lf)=%lf\n",x0,pdfvalo[ii]);
*/    
    x0+=(bb-aa)/numpdfpts;
 }
 do
 {
  x0 += (bb-aa)/20;
 } while(fnf(x0,pohat,model) > ymax/500.0  );

 bb = x0;

 xsteppdf = (bb-aa)/numpdfpts;
 xstephist = (bb-aa)/numhistpts;

 xaxislength=0.8*HRES;

 xscale= 0.8*HRES/(bb-aa);
 alpha = 0.1*HRES - xscale*aa;

 xstep=0.8*HRES/(numpts);

 yaxislength=VRES/1.2;

if(hitail==1 || hitail==0)
 yscale=-VRES/( 1.2*log(0.5/numpts) );
else
 yscale = VRES/(1.2);
 

ystep=VRES/(1.2*numpts);


/*---- plot axes ----*/
 n1=numpts/**1.2*/;

#if GRAPHICSON

 for(ii=0;ii<=n1;ii++) /*- x-axis, with ticks -*/
   {
   movegen((float)(ii*xstep) , 0);
   drawgen((float)((ii+1)*xstep),0);
   drawgen((float)((ii+1)*xstep),(float)dstep);
   }

 for(ii=0;ii<=numpts-1;ii++) /*- y-axis with ticks -*/
   {
   movegen(0,  (float) (ii*ystep) );
   drawgen(0,  (float) ((ii+1)*ystep));
   drawgen((float)dstep, (float) ((ii+1)*ystep));
   }

 movegen(0,(float)yaxislength);
 drawgen((float)xaxislength,(float)yaxislength);


// again:

 if(Dvalflag==0 || Dvalflag==1)
   printf("OPTIMIZED PARAMS: # of Components = %d\n",numcomps);
 else
   printf("INITIAL PARAMS: # of Components = %d\n",numcomps);


/* ==== draw x-axis ==== */
setcolgen(WHITE);
movegen(xscale*bb+alpha, 0);
drawgen(0,0);

#endif


/*============ plot EDF ==============*/
#if OUTPUTFILE
   fprintf(fdp,"%d\n",numpts); /* ----output in original units */
#endif

if(hitail==1 || hitail==0)
 yscale=-VRES/( 1.2*log(0.5/numpts) );
else
 yscale = VRES/(1.2);

#if GRAPHICSON
 setcolgen(LIGHTRED);
#endif

 for(ii=1;ii<=numpts;ii++)
   {
   xt=xscale*yobsno[ii] + alpha;
   if(hitail==0) yt=-yscale*log((ii-.5)/numpts);
   else if(hitail==1)
       yt=-yscale*log( 1.- (ii-.5)/numpts);
                                        /* plot -log-survivor function */
   else yt = yscale * (ii-0.5)/numpts;

#if GRAPHICSON
   movegen((float)(xt-dstep), (float)yt);
   drawgen((float)(xt+dstep), (float)yt);
   movegen((float)xt, (float)(yt-dstep) );
   drawgen((float)xt, (float)(yt+dstep) );
#endif

#if OUTPUTFILE
   fprintf(fdp,"%lf\t %lf\n",yobsno[ii], yt/yscale);/* output in original units */
#endif   

   }
#if OUTPUTFILE
// fprintf(fdp,"\n"); 
#endif
/*============ End of plot EDF ==============*/


/*=============== Draw Fitted CDF  ================*/
#if GRAPHICSON
  setcolgen(YELLOW);
#endif

#if OUTPUTFILE
/* fprintf(fdp,"%d\n",numpdfpts); */
#endif

cdf = 0.0;

#if GRAPHICSON
  movegen(0,0);
#endif

firstdrawnflag = 1;

fprintf(fdp,"%d\n",numpdfpts);

for(ii=1;ii<=numpdfpts;ii++)
   {
   switch(cdfavail)
     {
     case 0:
       xt = aa + 0.00001 + (ii-1)*xsteppdf;
       cdf =  quanc8(leftendvalue,xt,pohat);
       break;

     case 1:
       xt = aa + 0.00001 + (ii-1)*xsteppdf;
       cdf = explicitcdf(xt,pohat);
       break;
     }

   if(hitail==0) yt = -log(cdf+.00000001); /* plot -logsurvivor function */
   else if (hitail==1) yt = -log(1.0-cdf);
   else yt = cdf;

#if OUTPUTFILE
     fprintf(fdp,"%lf\t %lf\n",xt, yt); /* in original units */
#endif

   yt = yscale*yt;
   xt = xscale*xt+alpha;

#if GRAPHICSON
   if(yt<VRES && yt>0 && xt<HRES && xt>0)
     {
     if(firstdrawnflag==1) /*$$$$$*/
       {
       firstdrawnflag = 0; movegen( (float)(xt), (float)(yt) );
       }
     else
       drawgen( (float)(xt), (float)(yt) );
     }
#endif

   }
#if OUTPUTFILE
// fprintf(fdp,"\n"); 
#endif
/*--- end of draw of fitted integrated cdf  ---*/


/* ============= investigate the histogram and pdf ================ */

#if GRAPHICSON

  printf("Press key to continue (& for pdfvals) \n");
  akey=getchgen();

  clearscreengen();
  if(Dvalflag==0 || Dvalflag==1)
     printf("OPTIMIZED PARAMS: # of Components = %d\n",numcomps);
  else
     printf("INITIAL PARAMS: # of Components = %d\n",numcomps);
#endif

x0 = aa; /*=== x0 set to left end of chosen range ===*/

yscale = VRES/(1.2);

ymax = 0.0;

/*- calc pdfvals and find the largest in the range to be drawn -*/
for(ii=1;ii<=numpdfpts;ii++)
{
   pdfvalo[ii] = fnf(x0,pohat,model);
   if( (ymax<pdfvalo[ii]) ) ymax = pdfvalo[ii];
   x0+=xsteppdf;
   

   // if(akey=='&') printf("pdf(%lf)=%lf\n",x0,pdfvalo[ii]);
   
}

/*
printf("At A: ymax = %lf\n", ymax);
*/

/*==================================================
 Set cellht. The area under the pdf is unity. If each obsn
contributes an area xstephist*cellht, and there are numpts
obsns, then numpts*xstephist*cellht = 1
===================================================*/

cellht = 1.0/xstephist/numpts; 

/* === calc histopdf array and check max === */
for(j=1;j<=numhistpts;j++)
{
   histopdf[j] = 0.0;
}

for(ii=1;ii<=numpts;ii++)
{
   j = numhistpts * (yobsno[ii]-aa-0.0001)/(bb-aa) + 1.0;
   if( j>=1 && j<=numhistpts)
      histopdf[j] += 1.0;
}

for(ii=1;ii<=numhistpts;ii++)
{
   histopdf[ii] *= cellht;
   if(ymax < histopdf[ii]) ymax = histopdf[ii];
}

/*
printf("At B: ymax = %lf\n", ymax);
getchgen();
*/

#if GRAPHICSON
/* ----- draw the x-axis ---- */
  setcolgen(WHITE);
  movegen(xscale*(bb-aa)+alpha, 0);
  drawgen(0,0);
#endif

/* ===== draw the histogram ===== */

#if OUTPUTFILE
 fprintf(fdp,"%d\n",2*numhistpts+2 );
#endif

x0 = aa;

for(ii=1;ii<=numhistpts;ii++)
   {
   x1 = x0 + xstephist;

#if OUTPUTFILE
     if(ii==1)
       {
       fprintf(fdp,"%lf\t %12.8lf\n",x0, 0.0);           /* in original units */
       fprintf(fdp,"%lf\t %12.8lf\n",x0, histopdf[ii] );
       fprintf(fdp,"%lf\t %12.8lf\n",x1, histopdf[ii] );
       }
     else if (ii<numhistpts)
       {
       fprintf(fdp,"%lf\t %12.8lf\n",x0, histopdf[ii] ); /* in original units */
       fprintf(fdp,"%lf\t %12.8lf\n",x1, histopdf[ii] );
       }       
     else
       {
       fprintf(fdp,"%lf\t %12.8lf\n",x0, histopdf[ii] ); /* in original units */
       fprintf(fdp,"%lf\t %12.8lf\n",x1, histopdf[ii] );
       fprintf(fdp,"%lf\t %12.8lf\n",x1, 0.0 );
       }       
#endif

   xt0 = xscale*x0+alpha;
   xt1 = xscale*x1+alpha;
  
   x0 += xstephist;

   yt1 = yscale*histopdf[ii]/ymax;

#if GRAPHICSON
     if(ii==1) /*$$$$$*/
       {
       movegen( (float)(xt0), (float)(0) );
       drawgen( (float)(xt0), (float)(yt1) );
       drawgen( (float)(xt1), (float)(yt1) );
       }
     else if (ii<numhistpts)
       {
       drawgen( (float)(xt0), (float)(yt1) );
       drawgen( (float)(xt1), (float)(yt1) );
       }       
     else
       {
       drawgen( (float)(xt0), (float)(yt1) );
       drawgen( (float)(xt1), (float)(yt1) );
       drawgen( (float)(xt1), (float)(0) );
       }       
#endif
   }


#if GRAPHICSON
 printf("press key for components (a-all at once)\n");
 akey = getchgen();

#endif

/* ============ draw the PDF components ========== */
#if GRAPHICSON
  setcolgen(LIGHTBLUE);
#endif

for(j = 1; j<=numcomps; j++)
{

#if GRAPHICSON
   if(j!=9)
   {
      setcolgen( (5+j)%14 );
   }
   else
   {
      setcolgen( 5 );
   }
#endif

   firstdrawnflag = 1;  /*$$$$$*/
   x0 = aa;
   thetaptr = &pohat[3*(j-1)];
   if(componentmodel==NORMAL)
   {
      x0 = pohat[3*(j-1)+1] - 4.0*pohat[3*(j-1)+2];
      x1 = 8.0*pohat[3*(j-1)+2]/numpdfpts;
      fprintf(fdp,"%d\n",numpdfpts);
      for(ii=1;ii<=numpdfpts;ii++)
      {
         y0 = thetaptr[3] * fnf(x0,thetaptr,componentmodel);
         yt = yscale * y0 / ymax;
         xt = xscale*x0+alpha;
#if OUTPUTFILE
         fprintf(fdp,"%lf\t %12.8lf\n",x0, y0 ); /* in original units */
#endif
/*
	printf("xt=%lf yt=%lf\n",xt,yt);
*/

#if GRAPHICSON
         if(yt<VRES && yt>0 && xt<HRES && xt>0)
         {
            if(firstdrawnflag==1) /*$$$$$*/
            {
               firstdrawnflag = 0; movegen( (float)(xt), (float)(yt) );
            }
            else   drawgen( (float)(xt), (float)(yt) );
         }

#endif

         x0 += x1;
      }
   }
   else
   {
      fprintf(fdp,"%d\n",numpdfpts);
      for(ii=1;ii<=numpdfpts;ii++)
      {
         y0 = thetaptr[3] * fnf(x0,thetaptr,componentmodel);
         yt = yscale * y0 / ymax;
         xt = xscale*x0+alpha;
#if OUTPUTFILE
         fprintf(fdp,"%lf\t %12.8lf\n",x0, y0 ); /* in original units */
#endif
#if GRAPHICON
         if(yt<VRES && yt>0 && xt<HRES && xt>0)
         {

            if(firstdrawnflag==1) /*$$$$$*/
            {
               firstdrawnflag = 0; movegen( (float)(xt), (float)(yt) );
            }
            else   drawgen( (float)(xt), (float)(yt) );
         }
#endif

         x0 += xsteppdf;
      }
   }
#if OUTPUTFILE
//  fprintf(fdp,"\n"); 
#endif

#if GRAPHICSON
   if (akey!='a') getchgen();
#endif

}/*- j: components -*/
/* ===== end of draw of pdf components ===== */

if(numcomps==1) goto skipredrawlabel; // no need to draw the full pdf

/* ============ draw the PDF =========== */
#if OUTPUTFILE
/* fprintf(fdp,"%d\n",numpdfpts); */
#endif

firstdrawnflag = 1;  /*$$$$$*/
x0 = aa;

#if GRAPHICSON
  setcolgen(YELLOW);
#endif

fprintf(fdp,"%d\n",numpdfpts);
for(ii=1;ii<=numpdfpts;ii++)
{
   yt = yscale*pdfvalo[ii]/ymax;
   xt = xscale*x0+alpha;

#if OUTPUTFILE
     fprintf(fdp,"%lf\t %12.8lf\n",x0, pdfvalo[ii] ); /* in original units */
#endif

#if GRAPICSON
   if(yt<VRES && yt>0 && xt<HRES && xt>0)
     {
     if(firstdrawnflag==1) /*$$$$$*/
       {
       firstdrawnflag = 0; movegen( (float)(xt), (float)(yt) );
       }
     else   drawgen( (float)(xt), (float)(yt) );
     }
#endif

   x0 += xsteppdf;
}
#if OUTPUTFILE
// fprintf(fdp,"\n"); 
#endif
/* ========= end of draw of fitted  pdf  ======== */


skipredrawlabel:

;


// if(Dvalflag==0 || Dvalflag==1)
// {
//    printf("End of plots with this # of components. Redraw plots? (y/n)\n");
//    akey = getchgen();
//    if( (akey=='Y') || (akey=='y') )
//    {
//       printf("xmin = %lf xmax = %lf Select new values\n",aa,bb);
//       scanf("%lf %lf", &aa, &bb);
//       /*
//       if(aa<leftendvalue) aa=leftendvalue;
//       */
//       printf("numhistpts= %d. Select new value\n",numhistpts);
//       scanf("%d",&numhistpts);
//       xscale=0.8*HRES/(bb-aa);
//       alpha = 0.1*HRES - xscale*aa;
//       xstephist = (bb-aa)/numhistpts;
//       xsteppdf = (bb-aa)/numpdfpts;
//       clearscreengen();
//       goto again;
//    } 
// }
// else
// {
//    printf("Press key\n");
//    akey=getchgen();
// }

#if 0
/* ==== look at Dval: differences between fitted cdf and edf ===== */
if (Dvalflag==0) goto skipDlabel;
clearscreengen();
if(Dvalflag==0 || Dvalflag==1)
   printf("OPTIMIZED PARAMS: # of Components = %d\n",numcomps);
else
   printf("INITIAL PARAMS: # of Components = %d\n",numcomps);

 Dvalmax = -1e10;
 Dvalmin =  1e10;
 for(i=1;i<=numpts;i++)
 {
    if(Dval[i]>Dvalmax) Dvalmax = Dval[i];   
    if(Dval[i]<Dvalmin) Dvalmin = Dval[i];   
 }

 yscale = VRES/(1.2*(Dvalmax-Dvalmin));

 /*-- draw horizontal axis at Dval = 0 --*/
 setcolgen(WHITE);
 yt = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 movegen(0, (float)yt);
 drawgen(HRESM1,(float)yt);

 yt1 = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 for(ii=1;ii<numpts;ii++)
 {
    xt=xscale*yobsno[ii] + alpha;
    xt1=xscale*yobsno[ii+1] + alpha;
    yt = yscale * (Dval[ii]-Dvalmin) + (0.1/1.2)*VRES;

    if(j0<=ii && ii<=j1)
    {
       if(j2<=ii && ii<=j3)
          setcolgen(YELLOW);
       else
          setcolgen(RED);
    }
    else
    {
       if(j2<=ii && ii<=j3)
          setcolgen(MAGENTA);
       else
          setcolgen(CYAN);
    }
    if(ii==1)   movegen((float)(xt), (float)yt1);
    drawgen((float)(xt), (float)yt);
    drawgen((float)(xt1), (float)yt);
    yt1 = yt;
 }
 yt = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 drawgen((float)xt1, yt);

 /* ==== look at Dval: differences between fitted cdf and edf ===== */
 clearscreengen();
 if(Dvalflag==0 || Dvalflag==1)
    printf("OPTIMIZED PARAMS: # of Components = %d\n",numcomps);
 else
    printf("INITIAL PARAMS: # of Components = %d\n",numcomps);

 Dvalmax = -1e10;
 Dvalmin =  1e10;
 for(i=1;i<=numpts;i++)
 {
    if(Dval[i]>Dvalmax) Dvalmax = Dval[i];   
    if(Dval[i]<Dvalmin) Dvalmin = Dval[i];   
 }

 yscale = VRES/(1.2*(Dvalmax-Dvalmin));

 /*-- draw horizontal axis at Dval = 0 --*/
 setcolgen(WHITE);
 yt = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 movegen(0, (float)yt);
 drawgen(HRESM1,(float)yt);

 yt1 = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 for(ii=1;ii<numpts;ii++)
 {
    xt=(HRES/1.2)*(double)ii/n + (0.1/1.2)*HRES;
    xt1=(HRES/1.2)*(double)(ii+1.)/n + (0.1/1.2)*HRES;
    yt = yscale * (Dval[ii]-Dvalmin) + (0.1/1.2)*VRES;

    if(j0<=ii && ii<=j1)
    {
       if(j2<=ii && ii<=j3)
          setcolgen(YELLOW);
       else
          setcolgen(RED);
    }
    else
    {
       if(j2<=ii && ii<=j3)
          setcolgen(MAGENTA);
       else
          setcolgen(CYAN);
    }

    if(ii==1)   movegen((float)(xt), (float)yt1);
    drawgen((float)(xt), (float)yt);
    drawgen((float)(xt1), (float)yt);
    yt1 = yt;
 }
 yt = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 drawgen((float)(xt1), (float)yt);

getchgen();

skipDlabel:
#endif

#if 0
  Closegraphics();
#endif

}
/*-- end of graphplot --*/

#if GRAPHICSON

void Dvalplot(yobsno, n, pohat, adjustonflagptr, Dval, j0ptr, j1ptr, maxprobptr)
double * yobsno;
long n;
double * pohat;
long * adjustonflagptr;
double * Dval;
long * j0ptr, * j1ptr;
double * maxprobptr;

/*==== graph plot ====*/
{

extern double leftendvalue;


char akey;
double alpha;
double aa,bb;

double Dvalmax,Dvalmin;

long i,ii;
long ifault = 0;


long numpts;

double xscale;
double xt,xt1;

double ymax;
double yscale,ystep;       /*$$$$$*/
double yt,yt1;

Initgraphics();

numpts = n;

/* === set range limits === */
 aa = leftendvalue;
 bb = yobsno[numpts];

 xscale= 0.8*HRES/(bb-aa);
 alpha = 0.1*HRES - xscale*aa;

/* ==== draw x-axis ==== */
setcolgen(WHITE);
movegen(xscale*bb+alpha, 0);
drawgen(0,0);

/* ==== look at Dval: differences between fitted cdf and edf ===== */
clearscreengen();
printf("Adjust with a,s-j1 z,x-j0; y-try this one; e- to escape Dval loop\n");
printf("            d,f-j1 c,v-j0; (steplength 10)\n");
printf("Adjust with g,h-j1 b,n-j0; (steplength 100)\n");

*adjustonflagptr=2;
repeatlabel:
 Dvalmax = -1e10;
 Dvalmin =  1e10;
 for(i=1;i<=numpts;i++)
 {
    if(Dval[i]>Dvalmax) Dvalmax = Dval[i];   
    if(Dval[i]<Dvalmin) Dvalmin = Dval[i];   
 }

 yscale = VRES/(1.2*(Dvalmax-Dvalmin));

 /*-- draw horizontal axis at Dval = 0 --*/
 setcolgen(WHITE);
 yt = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 movegen(0, (float)yt);
 drawgen(HRESM1,(float)yt);

 yt1 = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 for(ii=1;ii<numpts;ii++)
 {
    xt=xscale*yobsno[ii] + alpha;
    xt1=xscale*yobsno[ii+1] + alpha;
    yt = yscale * (Dval[ii]-Dvalmin) + (0.1/1.2)*VRES;

    if(*j0ptr<=ii && ii<*j1ptr)
    {
       setcolgen(RED);
    }
    else
    {
       setcolgen(CYAN);
    }
    if(ii==1)   movegen((float)(xt), (float)yt1);
    drawgen((float)(xt), (float)yt);
    drawgen((float)(xt1), (float)yt);
    yt1 = yt;
 }
 yt = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 drawgen((float)xt1, yt);

 akey=getchgen();
 switch(akey)
 {
    case 'a': *j1ptr=*j1ptr-1; if(*j1ptr<=*j0ptr) *j1ptr=*j1ptr+1; break;
    case 's': *j1ptr=*j1ptr+1; if(*j1ptr>numpts) *j1ptr=*j1ptr-1; break;
    case 'z': *j0ptr=*j0ptr-1; if(*j0ptr<0) *j0ptr=*j0ptr+1; break;
    case 'x': *j0ptr=*j0ptr+1; if(*j0ptr>=*j1ptr) *j0ptr=*j0ptr-1; break;

    case 'd': *j1ptr=*j1ptr-10; if(*j1ptr<=*j0ptr) *j1ptr=*j1ptr+10; break;
    case 'f': *j1ptr=*j1ptr+10; if(*j1ptr>numpts) *j1ptr=*j1ptr-10; break;
    case 'c': *j0ptr=*j0ptr-10; if(*j0ptr<0)      *j0ptr=*j0ptr+10; break;
    case 'v': *j0ptr=*j0ptr+10; if(*j0ptr>=*j1ptr) *j0ptr=*j0ptr-10; break;

    case 'g': *j1ptr=*j1ptr-100; if(*j1ptr<=*j0ptr) *j1ptr=*j1ptr+100; break;
    case 'h': *j1ptr=*j1ptr+100; if(*j1ptr>numpts) *j1ptr=*j1ptr-100; break;
    case 'b': *j0ptr=*j0ptr-100; if(*j0ptr<0)      *j0ptr=*j0ptr+100; break;
    case 'n': *j0ptr=*j0ptr+100; if(*j0ptr>=*j1ptr) *j0ptr=*j0ptr-100; break;

    case 'e': *adjustonflagptr = 0; break; /* -- end adjusts -- */
    default: *adjustonflagptr = 1;   /* -- try this one -- */
 }
 if (*adjustonflagptr==2) goto repeatlabel;

 /* ==== look at Dval: differences between fitted cdf and edf ===== */
 clearscreengen();

 printf("Adjust with a,s-j1 z,x-j0; y-try this one; e- to escape Dval loop\n");
 printf("            d,f-j1 c,v-j0; (steplength 10)\n");
 printf("Adjust with g,h-j1 b,n-j0; (steplength 100)\n");

 *adjustonflagptr=2;
repeat2:
 Dvalmax = -1e10;
 Dvalmin =  1e10;
 for(i=1;i<=numpts;i++)
 {
    if(Dval[i]>Dvalmax) Dvalmax = Dval[i];   
    if(Dval[i]<Dvalmin) Dvalmin = Dval[i];   
 }

 yscale = VRES/(1.2*(Dvalmax-Dvalmin));

 /*-- draw horizontal axis at Dval = 0 --*/
 setcolgen(WHITE);
 yt = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 movegen(0, (float)yt);
 drawgen(HRESM1,(float)yt);

 yt1 = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 for(ii=1;ii<numpts;ii++)
 {
    xt=(HRES/1.2)*(double)ii/n + (0.1/1.2)*HRES;
    xt1=(HRES/1.2)*(double)(ii+1.)/n + (0.1/1.2)*HRES;
    yt = yscale * (Dval[ii]-Dvalmin) + (0.1/1.2)*VRES;

    if(*j0ptr<=ii && ii<*j1ptr)
    {
       setcolgen(RED);
    }
    else
    {
       setcolgen(CYAN);
    }

    if(ii==1)   movegen((float)(xt), (float)yt1);
    drawgen((float)(xt), (float)yt);
    drawgen((float)(xt1), (float)yt);
    yt1 = yt;
 }
 yt = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 drawgen((float)(xt1), (float)yt);

 akey=getchgen();
 switch(akey)
 {
    case 'a': *j1ptr=*j1ptr-1; if(*j1ptr<=*j0ptr) *j1ptr=*j1ptr+1; break;
    case 's': *j1ptr=*j1ptr+1; if(*j1ptr>numpts) *j1ptr=*j1ptr-1; break;
    case 'z': *j0ptr=*j0ptr-1; if(*j0ptr<0) *j0ptr=*j0ptr+1; break;
    case 'x': *j0ptr=*j0ptr+1; if(*j0ptr>=*j1ptr) *j0ptr=*j0ptr-1; break;

    case 'd': *j1ptr=*j1ptr-10; if(*j1ptr<=*j0ptr) *j1ptr=*j1ptr+10; break;
    case 'f': *j1ptr=*j1ptr+10; if(*j1ptr>numpts) *j1ptr=*j1ptr-10; break;
    case 'c': *j0ptr=*j0ptr-10; if(*j0ptr<0)      *j0ptr=*j0ptr+10; break;
    case 'v': *j0ptr=*j0ptr+10; if(*j0ptr>=*j1ptr) *j0ptr=*j0ptr-10; break;

    case 'g': *j1ptr=*j1ptr-100; if(*j1ptr<=*j0ptr) *j1ptr=*j1ptr+100; break;
    case 'h': *j1ptr=*j1ptr+100; if(*j1ptr>numpts) *j1ptr=*j1ptr-100; break;
    case 'b': *j0ptr=*j0ptr-100; if(*j0ptr<0)      *j0ptr=*j0ptr+100; break;
    case 'n': *j0ptr=*j0ptr+100; if(*j0ptr>=*j1ptr) *j0ptr=*j0ptr-100; break;

    case 'e': *adjustonflagptr = 0; break; /* -- end adjusts -- */
    default: *adjustonflagptr = 1;   /* -- try this one -- */
 }
 if (*adjustonflagptr==2) goto repeat2;

*maxprobptr = Dval[*j1ptr]-Dval[*j0ptr];
if(*maxprobptr<=0.0) *maxprobptr = 0.01;

Closegraphics();

}
/* ------- end of Dvalplot ------ */
#endif


#if GRAPHICSON
/**** quanc8 ****/

double quanc8(a,b,pohat)
 double a,b;
 double * pohat;

 {
 extern double myabs(double);
 extern double fnf(double, double *,long);
 
 double qright[33], eff[17], x[17],fsave[9][33], xsave[9][33];
 
 double area;
 
 double cor11;
 
 double esterr;
 
 double fmax;
 double fmin;
 double f0;

 long i;
 
 long j;

 long level;
 long levmin;
 long levmax;
 long levout;

 long nim;

 long nomax;
 
 long nofin;
 long nofun;
 
 double qdiff;
 double qleft;
 double qnow;
 double qprev;
 
 double result;
 double tolerr;

 double st;
 double stone;

 long tni;
 double temp;
 double tr;

 double w0,w1,w2,w3,w4;

 double x0;
 
/*-----------*/

 levmin=1;
 levmax=30;
 levout=6;

 nomax = 5000;  /*was 5000 then 32*/;

 nofin = nomax - 8*(levmax-levout+pow(2,(levout+1)) );
 w0=3956.0/14175.0;
 w1=23552.0/14175.0;
 w2=-3712.0/14175.0;
 w3=41984.0/14175.0;
 w4=-18160.0/14175.0;

 /*--init running sums to Zero--*/

 flag=0;
 result=0;
 cor11=0;
 errest=0;
 area=0;
 nofun=0;
 if (a>=b) return(0);

/*--init for 1st intvl--*/
 level=0;
 nim=1;
 x0=a;

x[16]=b;
qprev=0;

f0=fnf(x0,pohat, model);
fmax=f0;
fmin=f0;

stone=(b-a)/16       ;
x[8]=(x0+x[16])/2    ;
x[4]=(x0+x[8])/2     ;
x[12]=(x[8]+x[16])/2 ;
x[2]=(x0+x[4])/2     ;
x[6]=(x[4]+x[8])/2   ;
x[10]=(x[8]+x[12])/2 ;
x[14]=(x[12]+x[16])/2;

for(j=2;j<=16;j+=2)
 {
 eff[j]=fnf(x[j],pohat,model);

/*
 printf("j= %d \n",j); 
*/

 if( fmax<eff[j] ) fmax=eff[j];
 if( fmin>eff[j] ) fmin=eff[j];
 }

nofun=9;

/*central calculation */

lab1030:

x[1]=(x0+x[2])/2;
eff[1]=fnf(x[1],pohat,model);

for (j=3; j<=15; j+=2)
 {
 x[j]=(x[j-1]+x[j+1])/2;
 eff[j]=fnf(x[j],pohat,model);

 }
 
 nofun=nofun+8;
 
 st=(x[16]-x0)/16;
 
 qleft=(w0*(f0+eff[8])+w1*(eff[1]+eff[7])+w2*(eff[2]+eff[6])+w3*(eff[3]+eff[5])+w4*eff[4])*st;
 qright[level+1]=(w0*(eff[8]+eff[16])+w1*(eff[9]+eff[15])+w2*(eff[10]+eff[14])+w3*(eff[11]+eff[13])+w4*eff[12])*st;

 qnow=qleft+qright[level+1];

 qdiff=qnow-qprev;

 area=area+qdiff;
 
 /* intvl cgce test  */
 esterr=myabs(qdiff)/1023;

 tr=relerr*myabs(area);
 if(aerr>tr) tr=aerr;
 tolerr=tr*myabs(st)/stone;
 if( level<levmin) goto lab1260;
 if( level>=levmax) goto lab1470;
 if( nofun>nofin) goto lab1420;
 if( esterr<=tolerr) goto lab1490;

/* no cgce*/
lab1260:
 nim=2*nim;
 level=level+1;

/* store rh els for future use */
 for(i=1;i<=8;i++)
  {
  fsave[i][level]=eff[i+8];
  xsave[i][level]=x[i+8];
  }

 /*
 assemble lh els for use now
 */
 qprev=qleft;
 
 for(i=1;i<=8;i++)
  {
  j=-i;
  eff[2*j+18]=eff[j+9];
  x[2*j+18]=x[j+9];
  }
  goto lab1030;
 
 /*
 trouble section
 */
 lab1420:
  nofin=2*nofin;
  levmax=levout;
  flag=flag+(b-x0)/(b-a);
  goto lab1490;
 
 /* current lev is max */
 lab1470:
  flag=flag+1;

 /*--intvl cged, add to sums--*/
 lab1490:
  result=result+qnow;


  errest=errest+esterr;
  cor11=cor11+qdiff/1023;
 
/*--locate next intvl--*/
 lab1530:
  tni=2*(long)(nim/2);
  if (nim==tni) goto lab1580;
 nim=nim/2;
 level=level-1;
 goto  lab1530;
 lab1580:
  nim=nim+1;
 
  if (level<=0) goto lab1700;
 
 /*-- assemble els for next intvl --*/

 qprev=qright[level];
 x0=x[16];
 f0=eff[16];
 for(i=1;i<=8;i++)
  {
  eff[2*i]=fsave[i][level];
  x[2*i]=xsave[i][level];
  }
 goto  lab1030;

 /*
finalise and return
*/

lab1700:
 result=result+cor11;

 /*-- make sure errest<roundofferr --*/
 if (errest==0.0) return(result);
 
 lab1730:

 temp=myabs(result)+errest;
 if (temp!=myabs(result)) return(result);
 errest=2*errest;
 goto  lab1730;

}

double myabs(x)
 double x;
 {
 if(x>0) return(x);
 else return(-x);
 }

#endif
