/* >c.15tmain2 */
/*-----------------------------------


29 Dec 2012: Changed to receive datafilename as an argument

             Has Init.d and ParEsts.d as input and

             produces CdfPdfs.d as output


This is a plotter version only. Needs an input file

-------------------------------------*/
#define GRAPHICSON 0

#include "threep9.h"

#if GRAPHICSON
   #include "gengraph.h"
#endif

char * filedatptr;


// globals from plotdis2
long hitail;
long model;
long componentmodel;

long show;
long numevals;
long cdfavail;
long spacingsflag;
double leftendvalue;
double gamlog, gamlog1, gamlog2;
long numcomps;
long maxnumlevs;
long effort;
double * yobs;
long n;
long akey;



int main(int argc, char * argv[])

{/*0*/
 // read_data subroutine now included directly

 void fitter(long, double*);
 void plotdistn(long, double*);

 // ----subs  from plotdis2 ----
 double explicitcdf( double, double*);

 void fitstat( double*, long, double*, long, double*, double* );

 void graphplot(FILE *, double *, long, double *, long, double *, long, long, long, long);
 
 double leftendfind(long, double*, double, double );

 double gammalog(double, long);
 double bigphi(double);
 double incompgam(double, double, double, long);

 double quanc8(double, double, double * );



 char filename[20];
 long n;
 char akey;

 long show;


 double cdf;

 double delta= 1e-1;




 FILE * fout0;
 FILE * fparin;

 FILE * fdp;

 long i;
 long ifault=0;
 long igiven;

 long j;
 long j0, j1, j2, j3;
 long j0old,j1old;

 long leftendflag;

 double maxvalue,maxval1,maxval2, maxvaluesofar;
 double maxprobsofar, maxprobsofar1;
 double mux,sig;

 long narrowflag;
 long numcomps0, numcompsprev, numcompspres, numcompsnew;
 long numpar;
 long numpars;
 long nxplct;

 double obsmean, obssig;
 
 long onepass;

 double sampmean,sampsig,sampskew,samprange;
 double samplogmean, samplogsig, samphmean;
 
 double ssigma;

 double x0;


 static double Dval[NSIZE];
 static double param[PSIZE][PSIZE];
 static double parpres[PSIZE];


 static double phimas;

 static double segval,segval1;
 static double suml, sumlsq, sumy;

 static double tee;
 static double thetamas;

 static double upper;

 static double xt;

 static double yobsn[NSIZE];
 static double yobsno[NSIZE];


long * nptr;


static char DataFileName[20];
static char DataFolderInit[30];
static char DataFolderCdfPdfs[30];
static char DataFolderParEsts[30];



 FILE *fp;

 show = 0;

 filedatptr = filename; 


 strcpy(DataFileName, argv[1]); // Get the datafile name

 strcpy(DataFolderInit,DataFileName);
 strcat(DataFolderInit,"/Init.d");


 strcpy(DataFolderCdfPdfs,DataFileName);
 strcat(DataFolderCdfPdfs,"/CdfPdfs.d");

 strcpy(DataFolderParEsts,DataFileName);
 strcat(DataFolderParEsts,"/ParEsts.d");


 printf("datafile name = %s\n",DataFileName);
 printf("Input file = %s\n",DataFolderInit);


 printf("Output file = %s\n",DataFolderCdfPdfs);
 printf("Output file = %s\n",DataFolderParEsts);
 printf("\n");

 //printf("\nPress a key to continue");

 //getch();



 /* ===== read in data file ===== */
 fp = fopen(DataFolderInit,"r");

 /*== get num-pts ===*/
 fscanf(fp,"%d",nptr);
 n = *nptr;

 /*== get yobsno[]  ===*/
 for (i=1;i<=n;i++)
   {/*2*/
   fscanf(fp,"%lf\n",&yobsno[i]);
   if(show==4)
     {
     printf("y = %7.2lf ",yobsno[i]);
     if((i%4)==0)printf("\n");
     }
   }/*2*/
 if(show==4)printf("\n\n");

 for (i=1;i<n;i++)
   {/*3*/
   for (j=n-1;j>=i;j--)
   {/*4*/
     if (yobsno[j]>yobsno[j+1])
     {/*5*/
      x0 = yobsno[j];
      yobsno[j] = yobsno[j+1];
      yobsno[j+1] = x0;
      }/*5*/
    }/*4*/
    }/*3*/

 fclose(fp);


 printf("\n\n\n PLEASE WAIT\n");

/*=======  start ======*/
 show = 0;
 fdp = fopen(DataFolderCdfPdfs,"w");
 


 /*======== data already read into n, yobsno =========*/

 sampmean = 0; sampsig = 0;
 sampskew = 0.0;

 for(i=1;i<=n;i++)
   sampmean += yobsno[i];
 sampmean = sampmean/(double)n;

 for(i=1;i<=n;i++)
   sampsig += pow( yobsno[i]-sampmean, 2.0);
 sampsig = sqrt(sampsig/(double)n);

 for(i=1;i<=n;i++)
   sampskew += (yobsno[i]-sampmean) * pow( yobsno[i]-sampmean, 2.0);
 sampskew = sampskew/(double)n;
 sampskew = sampskew/sampsig;

 samprange = yobsno[n] - yobsno[1];

 // printf("sampmean = %lf sampsig = %lf sampskew = %lf\n",
 //        sampmean,sampsig,sampskew); 
 // printf(" yobsno[1]=%lf yobsno[%d]=%lf samprange = %lf\n",
 //         yobsno[1], n, yobsno[n], samprange);


/*-------- no location shift -------*/
 obsmean = sampmean;
 obssig = sampsig;

 obsmean = 0;
 obssig = 1;

 for(i=1;i<=n;i++)
 {
    yobsn[i] = yobsno[i];
 }


 fparin = fopen(DataFolderParEsts,"r"); // Param estimates

 fscanf(fparin, "%ld", &model);
 fscanf(fparin, "%ld", &numcomps0);

 fprintf(fdp,"%ld\n",numcomps0); // Output max number of components in a model

 for(numcomps=numcomps0; numcomps>=1; numcomps--)
 {/*numcomps*/
 
    fscanf(fparin,"%ld",&numpar); // numcomps really
 
    for(i=1; i<=numcomps; i++)
    {
       fscanf(fparin, "%lf %lf %lf",
           &param[numcomps][3*(i-1)+1],
           &param[numcomps][3*(i-1)+2],
           &param[numcomps][3*(i-1)+3]);
    }
 }

 fclose(fparin);


#if 0 //111111
// ------ foutput ------
 for(numcomps=numcomps0; numcomps>=1; numcomps--)
 {/*numcomps*/
 
   if(numcomps==1)
   {
     fprintf(fout0,"%ld\n", numcomps0);
   }

   fprintf(fout0,"%ld\n ", numcomps);

   numpars = 3 * numcomps;

   for(i=1;i<=numpars;i++)
   {

      fprintf(fout0,"%lf ", param[numcomps][i]);
      if(i%3==0)
      {
         fprintf(fout0,"\n");
      }
   }
 }/* numcomps */

 // ----- end of foutput

 fclose(fout0);

#endif //111111


//  printf("model is %ld: ", model);

 switch(model)
 {
 case XMIXTURE: akey = '3'; break;
 case NXMIXTURE: akey = '4'; break;
 case WMIXTURE: akey = '5'; break;
 case NMIXTURE: akey = '6'; break;
 case LMIXTURE: akey = '7'; break;
 case GMIXTURE: akey = '8'; break;
 case IMIXTURE: akey = '9'; break;
 }

 switch(akey)
   {
   case '0': case ')': model = MODEL; cdfavail = 1; leftendflag = -1; onepass =1; break;
   case '1': case '"': model = BURR; cdfavail = 1; leftendflag = 0; onepass =1; break;
   case '3':           model = XMIXTURE; componentmodel=EXTREME2; cdfavail = 1; leftendflag = -1; onepass = 0; break;
   case '4': case '$': model = NXMIXTURE; componentmodel=NEXTREME2; cdfavail = 1; leftendflag = -1; onepass = 0; break;
   case '5': case '%': model = WMIXTURE; componentmodel=WEIBULL2; cdfavail = 1; leftendflag = 0; onepass = 0; break;
   case '6': case '^': model = NMIXTURE; componentmodel=NORMAL; cdfavail = 1; leftendflag = -1; onepass = 0; break;
   case '7': case '&': model = LMIXTURE; componentmodel=LOGNORM2; cdfavail = 1; leftendflag = 0; onepass = 0; break;
   case '8': case '*': model = GMIXTURE; componentmodel=GAMMA2; cdfavail = 1; leftendflag = 0; onepass = 0; break;
   case '9': case '(': model = IMIXTURE; componentmodel=INVG2; cdfavail = 1; leftendflag = 0; onepass = 0; break;
   }

// printf("\n 0-LOWTAIL, 1-HITAIL, 2-CDF?\n");
// akey = getchgen();
akey = '2'; 
 switch(akey)
 {
    case '0': case ')': hitail = 0; break;
    case '1': case '!': hitail = 1; break;
    case '2': case '@': hitail = 2; break;
 }

 if(
    model== WMIXTURE ||
    model==LMIXTURE ||
    model==GMIXTURE ||
    model==IMIXTURE
   )
 {
    for(i=1;i<=n;i++)
    {
       if(yobsn[i]<=0.0)
       {
          yobsn[i]=yobsn[n]/(100.0*n);
          // printf("y[%d]<=0.0 resetting to %lf\n",i,yobsn[i]);
       }
    } 
 }


for(numcomps=1;numcomps<=numcomps0;numcomps++)
{
  
    

 for(i=1; i<=numcomps; i++)
 {
    parpres[3*(i-1)+1] = param[numcomps][3*(i-1)+1];
    parpres[3*(i-1)+2] = param[numcomps][3*(i-1)+2];
    parpres[3*(i-1)+3] = param[numcomps][3*(i-1)+3];
//    parpres[3*(i-1)+2] = pow(parpres[3*(i-1)+2], -0.5);
 }


 /* =====  cdf found by explicit formula or by quadrature ===== */
 
 /* --- set left support value --- */
 x0 = leftendfind(leftendflag,parpres,sampmean,sampsig);
 leftendvalue = x0;

 if(numcomps<numcomps0)
    graphplot(fdp, yobsno, n, parpres, 1, Dval, j0, j1, j2, j3);
 else
    graphplot(fdp, yobsno, n, parpres, 0, Dval, j0, j1, j2, j3);

}

fclose(fdp);


}/*0*/
